//
//  JNIWrapper.java
//
//  Created by marco on 16.09.08.
//  Copyright (c) 2008, __MyCompanyName__. All rights reserved.
//

import java.util.*;

public class JNIWrapper {

    static {
        // Ensure native JNI library is loaded
        //System.loadLibrary("JNIWrapper");
        System.loadLibrary("ServiceUSB");
    }

    public JNIWrapper() {
        //System.out.println("Instance created");
    }
    
     public int ServiceUSB_GetInputValue(int inDeviceIdentifier)
    {
        return ServiceUSBGetInputValue_method(inDeviceIdentifier);
    }
    
    public int ServiceUSB_GetOutputValue(int inDeviceIdentifier)
    {
        return ServiceUSBGetOutputValue_method(inDeviceIdentifier);
    }

    
    public int ServiceUSB_GetEXValue(int inDeviceIdentifier)
    {
        return ServiceUSBGetEXValue_method(inDeviceIdentifier);
    }
    
    public int ServiceUSB_GetEYValue(int inDeviceIdentifier)
    {
        return ServiceUSBGetEYValue_method(inDeviceIdentifier);
    }
    
    public int ServiceUSB_SetOutputValue(int value, int inDeviceIdentifier, long timeout)
    {
        return ServiceUSBSetOutputValue_method( value,inDeviceIdentifier,timeout);
    }
    
    public int ServiceUSBSendVendorRequest(int request, int wValue, int wIndex, int inDeviceIdentifier)
    {
        return ServiceUSBSendVendorRequest_method((byte) request,  wValue,  wIndex,  inDeviceIdentifier,  (long)60);
    }
    
    public int ServiceUSBGetBytesInReadBuffer(byte pipe, int inDeviceIdentifier)
    {
      return ServiceUSBGetBytesInReadBuffer_method( pipe,  inDeviceIdentifier);
    }
    
    public int ServiceUSBSetOutputValueBy16BitMask(String  theMask, int inDeviceIdentifier)
    {
      return ServiceUSBSetOutputValueBy16BitMask_method( theMask,  inDeviceIdentifier);
    }
    
    public int ServiceUSBSetOutputValueBy8BitMask(String  theMask, int inDeviceIdentifier)
    {
      return ServiceUSBSetOutputValueBy8BitMask_method( theMask,  inDeviceIdentifier);
    }
    
    public int ServiceUSBSetOutputValueBit(int theSymbol,int theBit, int inDeviceIdentifier)
    {
      return ServiceUSBSetOutputValueBit_method( (byte)theSymbol, (byte)theBit, inDeviceIdentifier);
    }
    
    public int ServiceUSBGetInputValueBit (int theBit, int inDeviceIdentifier)
    {
      return ServiceUSBGetInputValueBit_method((byte)theBit, inDeviceIdentifier);
    }


    native int native_method(String arg);
    native int ServiceUSBGetInputValue_method(int inDeviceIdentifier);
    native int ServiceUSBGetEXValue_method(int inDeviceIdentifier);
    native int ServiceUSBGetEYValue_method(int inDeviceIdentifier);
    native int ServiceUSBSetOutputValue_method(int value, int inDeviceIdentifier, long timeout);
    native int ServiceUSBGetOutputValue_method(int inDeviceIdentifier);
    native int ServiceUSBSendVendorRequest_method(byte request, int wValue, int wIndex, int inDeviceIdentifier, long timeout);
    native int ServiceUSBGetBytesInReadBuffer_method(byte pipe, int inDeviceIdentifier);
    native int ServiceUSBSetOutputValueBy16BitMask_method(String theMask, int inDeviceIdentifier);
    native int ServiceUSBSetOutputValueBy8BitMask_method(String theMask, int inDeviceIdentifier);
    native int ServiceUSBSetOutputValueBit_method(byte theSymbol,byte theBit, int inDeviceIdentifier);
    native int ServiceUSBGetInputValueBit_method(byte theBit, int inDeviceIdentifier);
    
    


    public static void main (String args[]) {
        // insert code here...
        System.out.println("Started JNIWrapper");
        JNIWrapper newjni = new JNIWrapper();
        int result1 = newjni.ServiceUSB_GetInputValue(0);
        int result2 = newjni.ServiceUSB_GetEXValue(0);
        int result3 = newjni.ServiceUSB_GetEYValue(0);
        int result5 = newjni.ServiceUSB_SetOutputValue(129,0,(long)60);
        int result4 = newjni.ServiceUSB_GetOutputValue(0);
        //int result6 = newjni.ServiceUSBSendVendorRequest(1, 4711,815,0);
        int result7 = newjni.ServiceUSBSetOutputValueBy16BitMask("000000001100110T",0);
        int result8 = newjni.ServiceUSBSetOutputValueBit('1',5,0);
        int result9 = newjni.ServiceUSBGetInputValueBit(0,0);
        System.out.println("GetInput " + result1);
        System.out.println("EX " + result2);
        System.out.println("EY " + result3);
        System.out.println("GetOutput " + result4);
         System.out.println("OSStatus SetoutputValue " + result5);
        System.out.println("OSStatus ServiceUSBSetOutputValueBit " + result8);
        System.out.println("ServiceUSBGetInputValueBit " + result9);
    }

}
