//
//  JNIWrapper.java
//
//  Created by marco on 16.09.08.
//  Copyright (c) 2008, __MyCompanyName__. All rights reserved.
//

import java.util.*;

public class JNIWrapper {

    static {
        // Ensure native JNI library is loaded
        //System.loadLibrary("JNIWrapper");
        System.loadLibrary("ServiceUSB");
    }

    public JNIWrapper() {
        System.out.println("Instance created");
    }
    
     public int ServiceUSB_GetInputValue(int inDeviceIdentifier)
    {
      return ServiceUSBGetInputValue_method(inDeviceIdentifier);
    }
    
    public int ServiceUSB_GetOutputValue(int inDeviceIdentifier)
    {
      return ServiceUSBGetOutputValue_method(inDeviceIdentifier);
    }
    
    public int ServiceUSB_GetEXValue(int inDeviceIdentifier)
    {
      return ServiceUSBGetEXValue_method(inDeviceIdentifier);
    }
    
    public int ServiceUSB_GetEYValue(int inDeviceIdentifier)
    {
      return ServiceUSBGetEYValue_method(inDeviceIdentifier);
    }
    
    public int ServiceUSB_SetOutputValue(int value, int inDeviceIdentifier, long timeout)
    {
      return ServiceUSBSetOutputValue_method( value,inDeviceIdentifier,timeout);
    }
    
    public int ServiceUSBSendVendorRequest(int request, int wValue, int wIndex, int inDeviceIdentifier)
    {
      return ServiceUSBSendVendorRequest_method((byte) request,  wValue,  wIndex,  inDeviceIdentifier,  (long)60);
    }
    
    public int ServiceUSBGetBytesInReadBuffer(byte pipe, int inDeviceIdentifier)
    {
      return ServiceUSBGetBytesInReadBuffer_method( pipe,  inDeviceIdentifier);
    }
    
    public int ServiceUSBSetOutputValueBy16BitMask(String  theMask, int inDeviceIdentifier)
    {
      return ServiceUSBSetOutputValueBy16BitMask_method( theMask,  inDeviceIdentifier);
    }
    
    public int ServiceUSBSetOutputValueBy8BitMask(String  theMask, int inDeviceIdentifier)
    {
      return ServiceUSBSetOutputValueBy8BitMask_method( theMask,  inDeviceIdentifier);
    }
    
    public int ServiceUSBSetOutputValueBit(int theSymbol,int theBit, int inDeviceIdentifier)
    {
      return ServiceUSBSetOutputValueBit_method( (byte)theSymbol, (byte)theBit, inDeviceIdentifier);
    }
    
    public String ServiceUSBReadBytesFromReadBuffer(byte pipe,int inDeviceIdentifier)
    {
      return ServiceUSBReadBytesFromReadBuffer_method(pipe,inDeviceIdentifier);
    }
    
    public int ServiceUSBWriteBytes(byte pipe, String sendString, int inDeviceIdentifier, long timeout)
    {
      return ServiceUSBWriteBytes_method(pipe, sendString, inDeviceIdentifier, timeout );
    }
    
    public String ServiceUSBGetInputValueAs16BitMask(int inDeviceIdentifier)
    {
      return ServiceUSBGetInputValueAs16BitMask_method( inDeviceIdentifier);
    }
    
    public String ServiceUSBGetInputValueAs8BitMask(int inDeviceIdentifier)
    {
      return ServiceUSBGetInputValueAs8BitMask_method( inDeviceIdentifier);
    }
    
     public char ServiceUSBGetInputValueBit (int theBit, int inDeviceIdentifier)
    {
      return ServiceUSBGetInputValueBit_method((byte)theBit, inDeviceIdentifier);
    }
    
    public boolean ServiceUSBTestInputValueBit (int theBit, int inDeviceIdentifier)
    {
      return ServiceUSBTestInputValueBit_method((byte)theBit, inDeviceIdentifier);
    }
    
    public boolean ServiceUSBCompareInputValue16BitMask(String theMask, int inDeviceIdentifier)
    {
      return ServiceUSBCompareInputValue16BitMask_method( theMask,  inDeviceIdentifier);
    }
    
    public boolean ServiceUSBCompareInputValue8BitMask(String theMask, int inDeviceIdentifier)
    {
      return ServiceUSBCompareInputValue8BitMask_method( theMask,  inDeviceIdentifier);
    }

    public int[] ServiceUSBPulseEngineWhileMouseButton( int[] engineStatus, int[]  inBits, int inDeviceIdentifier, long timeout)
    {
      return ServiceUSBPulseEngineWhileMouseButton_method( engineStatus, inBits, inDeviceIdentifier, timeout);
    }
    
    public int ServiceUSBPulseEngine( int[] engineStatus, int[]  inBits, int inDeviceIdentifier, long timeout)
    {
      return ServiceUSBPulseEngine_method( engineStatus, inBits, inDeviceIdentifier, timeout);
    }
    
    public int ServiceUSBGetDeviceCount()
    {
      return ServiceUSBGetDeviceCount_method();
    }
    
    public int ServiceUSBGetNextDeviceIdentifier (int inDeviceIdentifier)
    {
      return ServiceUSBGetNextDeviceIdentifier_method( inDeviceIdentifier);
    }
    
    public String ServiceUSBGetDeviceROMVersion (int inDeviceIdentifier)
    {
      return ServiceUSBGetDeviceROMVersion_method( inDeviceIdentifier);
    }
    public String ServiceUSBGetUSBDriverVersion (int inDeviceIdentifier)
    {
      return ServiceUSBGetUSBDriverVersion_method( inDeviceIdentifier);
    }
    
    public boolean ServiceUSBIs16BitDevice( int inDeviceIdentifier)
    {
      return ServiceUSBIs16BitDevice_method( inDeviceIdentifier);
    }
    
    public String ServiceUSBGetDeviceSerialnumber (int inDeviceIdentifier)
    {
      return ServiceUSBGetDeviceSerialnumber_method( inDeviceIdentifier);
    }
    
     public void ServiceUSBReleaseDevice (int inDeviceIdentifier)
    {
       ServiceUSBReleaseDevice_method( inDeviceIdentifier);
    }
    
    public void druckWas (){
      System.out.println("Jaaaaaaa");
    }
    
    public int ServiceUSBBubbele(Object theObject, int inDeviceIdentifier)
    {
      ServiceUSBBubbele_method( theObject,  inDeviceIdentifier);
     return 0;
    }
    

    native int native_method(String arg);
    native int ServiceUSBSetOutputValue_method(int value, int inDeviceIdentifier, long timeout);
    native int ServiceUSBGetInputValue_method(int inDeviceIdentifier);
    native int ServiceUSBGetEXValue_method(int inDeviceIdentifier);
    native int ServiceUSBGetEYValue_method(int inDeviceIdentifier);
    native int ServiceUSBGetOutputValue_method(int inDeviceIdentifier);
    native int ServiceUSBSendVendorRequest_method(byte request, int wValue, int wIndex, int inDeviceIdentifier, long timeout);
    native int ServiceUSBGetBytesInReadBuffer_method(byte pipe, int inDeviceIdentifier);
    native String ServiceUSBReadBytesFromReadBuffer_method(byte pipe, int inDeviceIdentifier);
    native int ServiceUSBWriteBytes_method(byte pipe, String sendString, int inDeviceIdentifier,long timeout);
    native int ServiceUSBSetOutputValueBy16BitMask_method(String theMask, int inDeviceIdentifier);
    native int ServiceUSBSetOutputValueBy8BitMask_method(String theMask, int inDeviceIdentifier);
    native String ServiceUSBGetInputValueAs16BitMask_method(int inDeviceIdentifier);
    native String ServiceUSBGetInputValueAs8BitMask_method(int inDeviceIdentifier);
    native int ServiceUSBSetOutputValueBit_method(byte theSymbol,byte theBit, int inDeviceIdentifier);
    native char ServiceUSBGetInputValueBit_method(byte theBit, int inDeviceIdentifier);
    native boolean ServiceUSBTestInputValueBit_method(byte theBit, int inDeviceIdentifier);
    native boolean ServiceUSBCompareInputValue16BitMask_method(String theMask, int inDeviceIdentifier);
    native boolean ServiceUSBCompareInputValue8BitMask_method(String theMask, int inDeviceIdentifier);
    native int[] ServiceUSBPulseEngineWhileMouseButton_method(int[] engineStatus, int[]  inBits, int inDeviceIdentifier,long timeout);
    native int ServiceUSBPulseEngine_method(int[] engineStatus, int[]  inBits, int inDeviceIdentifier,long timeout);
    native int ServiceUSBGetDeviceCount_method();
    native int ServiceUSBGetNextDeviceIdentifier_method(int inDeviceIdentifier);
    native String ServiceUSBGetDeviceROMVersion_method(int inDeviceIdentifier);
    native String ServiceUSBGetUSBDriverVersion_method(int inDeviceIdentifier);
    native boolean ServiceUSBIs16BitDevice_method(int inDeviceIdentifier);
    native String ServiceUSBGetDeviceSerialnumber_method(int inDeviceIdentifier);
    native void ServiceUSBReleaseDevice_method(int inDeviceIdentifier);
    
    
    
    native int ServiceUSBBubbele_method(Object theObject, int inDeviceIdentifier);

    public static void main (String args[]) {
        // insert code here...
        int result;
        int error;
        System.out.println("Started JNIWrapper");
        JNIWrapper newjni = new JNIWrapper();
        
        
        newjni.ServiceUSBBubbele(newjni, 0);
        
        
        /*
        System.out.println("ServiceUSB_GetInputValue " + newjni.ServiceUSB_GetInputValue(0));
        System.out.println("ServiceUSB_GetEXValue " + newjni.ServiceUSB_GetEXValue(0));
        System.out.println("ServiceUSB_GetEXValue " + newjni.ServiceUSB_GetEXValue(0));
        
        error = newjni.ServiceUSB_SetOutputValue(129,0,(long)60);
        if (error != 0)
          System.out.println("ServiceUSB_SetOutputValue returned error " + error);
        
        System.out.println("ServiceUSB_GetOutputValue " + newjni.ServiceUSB_GetOutputValue(0));
        
        error = newjni.ServiceUSBSendVendorRequest(1, 4711,815,0);
        if (error != 0)
          System.out.println("ServiceUSBSendVendorRequest returned error " + error);
        
        error = newjni.ServiceUSBSetOutputValueBy16BitMask("000000001100110T",0);
        if (error != 0)
          System.out.println("ServiceUSBSetOutputValueBy16BitMask returned error " + error);
        
        error = newjni.ServiceUSBSetOutputValueBit('1',5,0);
        if (error != 0)
          System.out.println("ServiceUSBSetOutputValueBit returned error " + error);

        System.out.println("ServiceUSBGetInputValueBit " + newjni.ServiceUSBGetInputValueBit(0,0));
        System.out.println("ServiceUSBReadBytesFromReadBuffer_method:"+ newjni.ServiceUSBReadBytesFromReadBuffer_method((byte)0,0));
        
        //String myString = new String("Hello Kitty");
        /*error = newjni.ServiceUSBWriteBytes((byte)0, "Hello Kitty", 0, (long) 60);
        if (error != 0)
          System.out.println("ServiceUSBWriteBytes returned error " + error);
        
        System.out.println("ServiceUSBGetInputValueAs16BitMask:" + newjni.ServiceUSBGetInputValueAs16BitMask(0));
        
        if (newjni.ServiceUSBIs16BitDevice_method(0)){
          System.out.println("Is16Bit");
        } else {
          System.out.println("Is8Bit");
        }
        
        
        System.out.println("DeviceCount=" + newjni.ServiceUSBGetDeviceCount());
        
        System.out.println("ServiceUSBGetNextDeviceIdentifier=" + newjni.ServiceUSBGetNextDeviceIdentifier(0));
        System.out.println("ServiceUSBGetDeviceROMVersion=" + newjni.ServiceUSBGetDeviceROMVersion(0));
        System.out.println("ServiceUSBGetUSBDriverVersion=" + newjni.ServiceUSBGetUSBDriverVersion(0));*/

        
        int []myArray = {100,200,300,400,111};
        
        int[] C_createdArray = newjni.ServiceUSBPulseEngineWhileMouseButton(myArray,myArray,0,(long)60);
        System.out.println("Java:C_createdArray.size:" + C_createdArray.length);
        System.out.println("Java:C_createdArray contents:"+ C_createdArray[0] + " ; " + C_createdArray[1] + " ; " + C_createdArray[2] + " ; " + C_createdArray[3]);
        System.out.println("Java:[]myArray = " + myArray[0] + " " + myArray[1]);
          
    }

}
